; Commodore 64 - MOS 6510  Assembly sourcefile
; MIRROR.ASM
;   mirrors 8 bytes in their places (MSB <--> LSB)

.ENTRY start ; entry point

* = $4000

start  lda #<work
       ldy #>work
       sta $FD          ; zero page address
       sty $FE
       ldy #len
newbyte lda #7           ; number of bits - 1
       sta tmp
       lda ($FD),y
newbit  asl a
       pha
       txa
       ror a
       tax
       pla
       dec tmp
       bpl newbit
       txa
       sta ($FD),y
       dey
       bpl newbyte
       brk

tmp    .byte 0
; the 8 bytes to mirror:
work   .byte $F0, $80, $55, $69, $60, 0, $12, $2F
workend = *
len = workend - work - 1 ; number of bytes
